// место задания глобальный переменных
// ТИП ИМЯ;
// для ТИ 
// VAR_TI a1;
// можно сразу несколько
// VAR_TI a1,b,c,d;
// можно массив (не увлекаться - размер памяти ограничен)
// VAR_TI a[10];
// для TS
// VAR_TS b1;

VAR_TI value;

void dev iceInit() {  
// Тут можно задать значения переменных при старте однократно
// например a1 = 120.5;
}

void UserProgrammCycle(){
// Тут пишем программу

	CLEAR_ERROR();	// сброс признака ошибки возникающей при чтении недостоверных телепараметров

// пример работы с ТИ
	value = TI_READ(1)+TI_READ(2)+TI_READ(3);	// сумма трех ТИ с адресами 1 2 и 3
	
	TI_WRITE( 15, value, VAR_ERROR );	// запись ТИ 15 результата с учетом наличия ошибки
	// т.е. если хоть один из трех параметров был недостоверным то и результат станет недостоверным
	//	TI_WRITE( 15, value, SET_OK );	// запись ТИ 15 результата всегда достоверным
	//	TI_WRITE( 15, value, SET_ERROR );	// запись ТИ 15 результата всегда недостоверным
// тоже самое действие можно записать как явная проверка	
	if( VAR_ERROR )	TI_WRITE( 15, 0, SET_ERROR );
	else						TI_WRITE( 15, value, SET_OK );
	
	// внимание! запись типа
	// TI_WRITE( 15, TI_READ(1)+TI_READ(2)+TI_READ(3), VAR_ERROR );
	// будет некорректной поскольку значение VAR_ERROR будет использовано до операций доступа 
  // 	к ТИ1-3 и не будет отражать реальную достоверность этих параметров
	// т.е. расчет будет правильным, но без учета достоверности

	CLEAR_ERROR();	//сброс ошибки для следующих операций
	
// пример работы с ТС
// проверяем если ТС4 и ТС5 включены то делаем ТС3 включенным иначе ТС3 = выключено
// обратите внимание что отдельные условия в операторе if нужно закрывать 
// скобками для задания явного приоритета операций
	if( (TS_READ(4) == TS_ON) && (TS_READ(5) == TS_ON) )
		{ // если оба включены 
		TS_WRITE( 3, TS_ON, VAR_ERROR );
		}
	else	
		{	// если хоть один выключен
		TS_WRITE( 3, TS_OFF, VAR_ERROR );
		}
	CLEAR_ERROR();	//сброс ошибки для следующих операций

// пример работы со временем
// есть доступные переменные содержащие текущее время
// TIME_HOUR  текущий час
// TIME_MIN текущая минута
// TIME_SEC текущая секунда
// ниже запись в ТИ с адресом 16  значения текущей секуды в часе
	TI_WRITE( 16, (TIME_MIN*60)+TIME_SEC, SET_OK );
}
