echo off
set CC="..\..\GCC_ARM\bin\arm-none-eabi-gcc-4.9.3.exe"
set CCOPTS=-c -mcpu=cortex-m4 -mfpu=fpv4-sp-d16 -mfloat-abi=hard -mthumb -w -Wall -ffunction-sections -Os  -DSTM32F405VG -D__FPU_USED -DIEC61131 -DSUPPRESS_FORMATTED_OUTPUT -DGCC_C -DLOGIC -DDUMMY_IO_ -I. -o sind_task.o
set CCOPTS2=-c -mcpu=cortex-m4 -mfpu=fpv4-sp-d16 -mfloat-abi=hard -mthumb -w -Wall -ffunction-sections -Os  -DSTM32F405VG -D__FPU_USED -DIEC61131 -DSUPPRESS_FORMATTED_OUTPUT -DGCC_C -DLOGIC -DDUMMY_IO_ -I. 
set CL="..\..\GCC_ARM\bin\arm-none-eabi-gcc-4.9.3.exe"
set CB="..\..\GCC_ARM\bin\arm-none-eabi-objcopy.exe"
set CI="..\..\GCC_ARM\bin\arm-none-eabi-readelf.exe"
set CLILIST=-mcpu=cortex-m4 -mfpu=fpv4-sp-d16 -mfloat-abi=hard -mthumb -Wall -g -nostartfiles -Wl,-Map=IEC61131.map -Os -Wl,--gc-sections -L. -Wl,-Tarm-gcc-link.ld -g obj\system_stm32f4xx.o obj\startup_stm32f405xx.o main.o -lm -lgcc -lc

del %1.hex >>nul 
echo # Translate %2

cd .\Notepad++\GCC_ARM\Sincom_D\
rem copy %2 .\user_task.c >>nul
ECHO #include  "%2" >.\user_task.c
rem ECHO const BYTE VersC[]="%%~n%2 %%~t%2 "; >.\Vers.c
ECHO const BYTE VersC[]="%1 %date% %time%"; >.\Vers.c

%CC% %CCOPTS2% main.c || goto errorexit
%CL% %CLILIST%  -oIECtask.elf  || goto errorexit
%CB% -O binary -j .text IECtask.elf IECtask.bin
%CB% -O verilog -j .text IECtask.elf IECtask.hex
copy IECtask.hex %3\%1.hex >>nul


rem echo * RESULT SUCCESS
echo # ****************************************
echo #  %1.hex Ready load to SincomD controller!  *
echo # ****************************************
exit /b 0     

:errorexit
echo ##**********************************
echo ## ERROR! Make %1.hex not posible...  *
echo ##**********************************
exit /b 1
